help_text = """
Commandline Options:
-h HOST, --host HOST\tHost to connect to
-u USER, --user USER\tUsername to be used for authentication
-p, --password\t\tPrompt for password (must use if not "" ;-))
-f FILE, --infile FILE\tfile name of the ZOQL script to be executed
--help\t\t\tThis help
"""


_create_product = ''' \
CREATE PRODUCT Product AS [ZCLASS|PYTHON];
'''

_create_class = ''' \
CREATE CLASS ObjectType IN Product
  [ SET property assignmentOperator value [, ...] ]
  [ OPTION creationOption assignmentOperator value [, ...] ]
  [ DECLARE [ DEFAULT|PropertySheetName ] {
     PropertyName : PropertyType [ DEFAULT value ]
     [, ...] } ]
  [ DECLARE ... ]
  [ INHERIT ObjectType [, ...] ];
'''

_create_index = ''' \
CREATE INDEX indexName ON ObjectType [, ...]
  ( property [, ...] )
  [WHERE <CLAUSE>]
  [RECURSIVE];
'''

_alter_class = ''' \
ALTER CLASS {ProductName.ClassName|ObjectManagerInstance.Instance}
  ADD {PROPERTY|METHOD} PropertyName : PropertyType [ DEFAULT value ];

ALTER CLASS {ProductName.ClassName|ObjectManagerInstance.Instance}
  RENAME {PROPERTY|METHOD} OldPropertyName TO NewPropertyName;

ALTER CLASS {ProductName.ClassName|ObjectManagerInstance.Instance}
  DELETE {PROPERTY|METHOD} OldPropertyName TO NewPropertyName;
'''

_insert = ''' \
INSERT ObjectType 
  INTO Product[.ObjectType]
  SET [propertysheet.]property assignmentOperator value [, ...];

INSERT ObjectType 
  INTO ObjectManagerInstance
  SET [propertysheet.]property assignmentOperator value [, ...];
'''

_update = '''
UPDATE ObjectType [, ...]
  [IN ObjectManagerInstance [, ...]]
  SET [PropertySheet.]Property assignmentOperator value [, ...]
  [WHERE <CLAUSE>]
  [RECURSIVE];
'''

_delete = '''
DELETE ObjectType [, ...]
  [FROM ObjectManagerInstance [, ...]]
  [WHERE <CLAUSE>]
  [RECURSIVE];
'''

_select = '''
SELECT * | ALL | {ObjectType [, ...]}
  [FROM [PRODUCT] ObjectManagerInstance [, ...]]
  [WHERE <CLAUSE>]
  [ORDER BY Property [ ASC | DESC ] [, ...]]
  [LIMIT count [ OFFSET start ]]
  [RECURSIVE];
'''

zoql_help = {'CREATE PRODUCT': _create_product, 'CREATE CLASS': _create_class,
             'CREATE INDEX': _create_index, 'ALTER CLASS': _alter_class, 'INSERT': _insert,
             'UPDATE': _update, 'DELETE': _delete, 'SELECT': _select,
             'CREATE': _create_product + '\n' + _create_class  + '\n' + _create_index,
             'ALTER': _alter_class}
