"""The builder module provides nice builder/factory-functions to set
up instances of whatever turns you on.  Make sure you use these
methods instead of accessing the classes directly; 'cus that's a
no-no."""

import Product, Klass, Method, Property


def zope_product_builder(*args, **kw):
    """Helper-method for building a zope_product instance"""
    return apply(Product.ZopeProduct, args, kw)


def klass_product_builder(*args, **kw):
    """Helper-method for building a klass_product instance"""
    return apply(Product.KlassProduct, args, kw)


def basic_product_builder(*args, **kw):
    """Helper-method for building a basic_product instance"""
    return apply(Product.KlassProduct, args, kw)


def klass_builder(*args, **kw):
    """Helper-method for building a klass instance"""
    return apply(Klass.Klass, args, kw)


def property_klass_builder(*args, **kw):
    """Helper-method for building a property_klass instance"""
    return apply(Klass.PropertyKlass, args, kw)


def klass_rendrer_builder(*args, **kw):
    """Helper-method for building a property_klass instance"""
    return apply(Klass.KlassRendrer, args, kw)


def property_klass_rendrer_builder(*args, **kw):
    """Helper-method for building a property_klass instance"""
    return apply(Klass.PropertyKlassRendrer, args, kw)


def method_klass_rendrer_builder(*args, **kw):
    """Helper-method for building a property_klass instance"""
    return apply(Klass.MethodKlassRendrer, args, kw)


def method_klass_builder(*args, **kw):
    """Helper-method for building a property_klass instance"""
    return apply(Klass.MethodKlass, args, kw)


def basic_klass_builder(*args, **kw):
    """Helper-method for building a basic_klass instance"""
    return apply(Klass.BasicKlass, args, kw)


def method_builder(*args, **kw):
    """Helper-method for building a method instance"""
    return apply(Method.Method, args, kw)


def property_builder(*args, **kw):
    """Helper-method for building a property instance"""
    return apply(Property.Property, args, kw)

