"""Classes for manipulating properties/attributes"""

class BasicProperty:
    """A basic property class"""

    _properties = ({'id': 'id',      'type': 'string', 'default': 'id'},
                   {'id': 'type',    'type': 'string', 'default': 'string'},
                   {'id': 'default', 'type': 'string', 'default': "''"},
                   {'id': 'mode',    'type': 'string', 'default': 'w'})


    def __init__(self, **kw):
        """Initialize an instance of the class"""

        for property in self._properties:
            if property['id'] in kw.keys():
                setattr(self, property['id'], kw[property['id']])
            else:
                if property['type'] == 'list':
                    default = list(property['default'])
                else:
                    default = property['default']
                setattr(self, property['id'], property['default'])



class PropertyRendrer(BasicProperty):
    """Provides basic_property class with methods for rendering itself
    to text"""

    def render_self(self, indent=''):
        """Render the property instance in text.  This will be
        used when the product class will write itself out to
        the filesystem."""
        if self.type == 'string':
            default = self.default or ''
            default = "'" + default + "'"
        else:
            default = self.default
            
        return indent + ( "{'id' : '" + self.id +
                          "', 'type' : '" + self.type + 
                          "', 'mode' : '" + self.mode + 
                          "', 'default' : " + str(default) +
                          "}" )



class Property(PropertyRendrer):
    """This class represents a Zope-type property"""
    pass




