#!/usr/bin/python
"""Tests for the klass.py-module."""

# $Id: test_klass.py,v 1.1.2.1 2002/01/10 06:33:44 srichter Exp $
# $Source: /cvs/ZOQLMethod/MakeProduct/tests/Attic/test_klass.py,v $
__version__ = "$Revision: 1.1.2.1 $"[11:-2]

import unittest
import builder
import os

class basic_klass_test_case(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')

    def runTest(self):
        """basic_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.subklasses == [], \
               "runTest failed on subklasses"

class basic_klass_list_subklasses(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')

    def test_list_subklasses(self):
        """test_list_subklasses"""
        assert self.klass.list_subklasses() == [], \
               "test_list_subklasses failed on []"

class basic_klass_add_subklass(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')
        self.klass.add_subklass(builder.klass_builder(id='id'))

    def test_add_subklass(self):
        """test_add_subklass"""
        assert self.klass.list_subklasses()[0].id == 'id', \
               "test_add_subklass failed on 'id'"

class basic_klass_add_duplicate_subklass(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')
        self.klass.add_subklass(builder.klass_builder(id='id'))

    def test_add_duplicate_subklass(self):
        """test_add_duplicate_subklass"""
        try:
            self.klass.add_subklass(builder.klass_builder(id='id'))
        except "DuplicateSubklass":
            pass
        else:
            fail("Expected DuplicateSubklass error")

class basic_klass_remove_subklass(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')
        self.klass.add_subklass(builder.klass_builder(id='id'))

    def test_remove_subklass(self):
        """test_remove_subklass"""
        self.klass.remove_subklass('id')
        assert self.klass.list_subklasses() == [], \
               "test_add_subklass failed on list_subklasses()"

class basic_klass_get_subklass(unittest.TestCase):
    """This test case will test a basic_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.basic_klass_builder(id='id')
        self.klass.add_subklass(builder.klass_builder(id='id'))

    def test_get_subklass(self):
        """test_get_subklass"""
        assert self.klass.get_subklass('id').id == 'id', \
               "test_get_subklass failed on 'id'"

class method_klass_test_case(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')

    def runTest(self):
        """method_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.methods == [], \
               "runTest failed on methods"

class method_klass_list_methods(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')

    def test_list_methods(self):
        """test_list_methods"""
        assert self.klass.list_methods() == [], \
               "test_list_methods failed on list_methods()"

class method_klass_add_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))

    def test_add_method(self):
        """test_add_method"""
        assert self.klass.list_methods()[0].id == 'id', \
               "test_list_methods failed on 'id'"

class method_klass_add_duplicate_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))

    def test_add_duplicate_method(self):
        """test_add_duplicate_method"""
        try:
            self.klass.add_method(builder.method_builder(id='id'))
        except "DuplicateMethod":
            pass
        else:
            fail("Expected DuplicatedMethod error")

class method_klass_remove_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))

    def test_remove_method(self):
        """test_remove_method"""
        self.klass.remove_method('id')
        assert self.klass.list_methods() == [], \
               "test_remove_method failed on []"

class method_klass_get_method(unittest.TestCase):
    """This test case will test a method_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))

    def test_get_method(self):
        """test_get_method"""
        assert self.klass.get_method('id'), \
               "test_remove_method failed on []"

class method_klass_rendrer_render_methods(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_rendrer_builder(id='id')

    def test_render_methods(self):
        """test_render_methods, no methods"""
        assert self.klass._render_methods() == "", \
               "test_render_methods failed on _render_methods()"

class method_klass_rendrer_render_methods_one_method(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_rendrer_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))

    def test_render_methods(self):
        """test_render_methods, one method"""
        text = '''security.declarePublic('id')\ndef id(self):\n    """doc string"""\n    pass\n\n'''
        assert self.klass._render_methods() == text, \
               "test_render_methods failed on _render_methods()"

class method_klass_rendrer_render_methods_two_methods(unittest.TestCase):
    """This test case will test a method_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.method_klass_rendrer_builder(id='id')
        self.klass.add_method(builder.method_builder(id='id'))
        self.klass.add_method(builder.method_builder(id='id2'))

    def test_render_methods(self):
        """test_render_methods, two methods"""
        text = '''security.declarePublic('id')\ndef id(self):\n''' + \
               '''    """doc string"""\n    pass\n\n''' + \
               '''security.declarePublic('id2')\ndef id2(self):\n''' + \
               '''    """doc string"""\n    pass\n\n'''
        assert self.klass._render_methods() == text, \
               "test_render_methods failed on _render_methods()"

class property_klass_test_case(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')

    def runTest(self):
        """property_klass_test_case"""
        assert self.klass.id == 'id', \
               "runTest failed on 'id'"
        assert self.klass.properties == [], \
               "runTest failed on properties"

class property_klass_list_properties(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')

    def test_list_properties(self):
        """test_list_properties"""
        assert self.klass.list_properties() == [], \
               "test_list_properties failed on []"

class property_klass_add_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_add_property(self):
        """test_add_property"""
        assert self.klass.list_properties()[0].id == 'id', \
               "test_add_property failed on []"

class property_klass_add_duplicate_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_add_duplicate_property(self):
        """test_add_duplicate_property"""
        try:
            self.klass.add_property(builder.property_builder(id='id'))
        except "DuplicateProperty":
            pass
        else:
            fail("Excepted DuplicateProperty error")

class property_klass_remove_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_remove_property(self):
        """test_remove_property"""
        self.klass.remove_property('id')
        assert self.klass.list_properties() == [], \
               "test_remove_property failed on []"

class property_klass_get_property(unittest.TestCase):
    """This test case will test a property_klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_get_property(self):
        """test_get_property"""
        assert self.klass.get_property('id'), \
               "test_get_property failed on 'id'"

class property_klass_rendrer_render_properties(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')

    def test_render_properties(self):
        """test_render_properties, no properties"""
        assert self.klass._render_properties() == "", \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_one_property(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_render_properties(self):
        """test_render_properties, one property"""
        text = "        {'id':'id', 'type':'string', 'default':'', 'mode':'w'}"
        assert self.klass._render_properties() == text, \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_two_properties(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))
        self.klass.add_property(builder.property_builder(id='id2'))

    def test_render_properties(self):
        """test_render_properties, two properties"""
        text = "        {'id':'id', 'type':'string', 'default':'', 'mode':'w'},\n"+ \
               "        {'id':'id2', 'type':'string', 'default':'', 'mode':'w'}"
        assert self.klass._render_properties() == text, \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_dictionary(unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, no properties"""
        assert self.klass._render_properties() == "", \
               'test_render_properties failed on ""'

class property_klass_rendrer_render_properties_dictionary_one_property(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, one property"""
        text = "    _properties = (\n        {'id':'id', "+ \
               "'type':'string', 'default':'', 'mode':'w'}\n        )\n"
        assert self.klass._render_properties_dictionary() == text, \
               'test_render_properties_dictionary failed on "text"'

class property_klass_rendrer_render_properties_dictionary_two_properties(
    unittest.TestCase):
    """This test case will test a property_klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.property_klass_rendrer_builder(id='id')
        self.klass.add_property(builder.property_builder(id='id'))
        self.klass.add_property(builder.property_builder(id='id2'))

    def test_render_properties_dictionary(self):
        """test_render_properties_dictionary, two properties"""
        text = "    _properties = (\n        {'id':'id', "+ \
               "'type':'string', 'default':'', 'mode':'w'},\n"+ \
               "        {'id':'id2', 'type':'string', "+\
               "'default':'', 'mode':'w'}\n        )\n"
        assert self.klass._render_properties_dictionary() == text, \
               'test_render_properties_dictionary failed on "text"'

class klass_rendrer_render_license(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_license(self):
        """test_render_license"""
        assert self.klass._render_license() == '', \
               "test_render_license failed on ''"

class klass_rendrer_render_name_and_subclasses(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_name_and_subclasses(self):
        """test_render_name_and_subclasses"""
        text = "class id(SimpleItem,\n    base_item.base_item):\n"
        assert self.klass._render_name_and_subclasses() == text, \
               "test_render_name_and_subclasses failed on 'text'"

class klass_rendrer_render_imports(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_imports(self):
        """test_render_imports"""
        text = "from OFS.SimpleItem import SimpleItem\n" + \
               "from Globals import DTMLFile, InitializeClass\n" + \
               "from AccessControl import ClassSecurityInfo\n" + \
               "import base_item\n"
        assert self.klass._render_imports() == text, \
               "test_render_imports failed on 'text'"

class klass_rendrer_render_misc_definitions(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_misc_definitions(self):
        """test_render_misc_definitions"""
        text = "    meta_type = ''\n    icon = ''\n"
        assert self.klass._render_misc_definitions() == text, \
               "test_render_misc_definitions failed on 'text'"

class klass_rendrer_render_meta_types_and_accessor_calls(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_meta_types_and_accessor_calls(self):
        """test_render_meta_types_and_accessor_calls"""
        text = ""
        assert self.klass._render_meta_types_and_accessor_calls() == text, \
               "test_render_meta_types_and_accessor_calls failed on 'text'"

class klass_rendrer_render_accessors(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_accessors(self):
        """test_render_accessors"""
        text = ""
        assert self.klass._render_accessors() == text, \
               "test_render_accessors failed on 'text'"

class klass_rendrer_render_misc_headers(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_misc_headers(self):
        """test_render_misc_headers"""
        text = ""
        assert self.klass._render_misc_headers() == text, \
               "test_render_misc_headers failed on 'text'"

class klass_rendrer_render_add_function(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_add_function(self):
        """test_render_add_function"""
        text = "%(id)s_add_form = DTMLFile('dtml/%(id)s_add_form', globals())\n\n" % \
               {'id': 'id'}
        text = text + """def manage_add_%(id)s(self, id, REQUEST=None, **kw):
    \"\"\"Add an instance of the %(id)s class\"\"\"
    self._setObject(id, %(id)s(id, kw))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)\n""" % {'id': 'id'}
        assert self.klass._render_add_function() == text, \
               "test_render_add_function failed on 'text'"

class klass_rendrer_render_initialize_class(unittest.TestCase):
    """This test case will test a klass_rendrer instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_rendrer_builder(id='id')

    def test_render_initialize_class(self):
        """test_render_initialize_class"""
        text = "InitializeClass(id)\n"
        assert self.klass._render_initialize_class() == text, \
               "test_render_initialize_class failed on 'text'"

class klass_add_subklass_test_duplication(unittest.TestCase):
    """This test case will test a klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_builder(id='id')
        self.other_klass = builder.klass_builder(id='id2')
        self.klass.add_subklass(builder.klass_builder(id='id'))

    def test_add_subklass_duplication(self):
        """test_add_subklass_duplication"""
        assert self.other_klass.list_subklasses() == [], \
               "test_add_subklass_duplication failed on '[]'"

class klass_add_add_form(unittest.TestCase):
    """This test case will test a klass instance"""

    def setUp(self):
        """Set up necessities for this test"""
        self.klass = builder.klass_builder(id='id')
        self.directory = 'test_prod'
        os.mkdir(self.directory)
        os.mkdir(os.path.join(self.directory, 'dtml'))
        self.klass._write_add_form(self.directory)

    def test_add_add_form(self):
        """test_add_add_form"""
        assert os.path.isfile(
            os.path.join(self.directory, 'dtml', 'id_add_form.dtml')), \
            "test_add_add_form failed on 'isfile'"

    def tearDown(self):
        """Leaving things the way we found them"""
        os.remove(os.path.join(self.directory, 'dtml', 'id_add_form.dtml'))
        os.rmdir(os.path.join(self.directory, 'dtml'))
        os.rmdir(self.directory)

basic_klass_suite = unittest.TestSuite()
basic_klass_suite.addTest(basic_klass_test_case("runTest"))
basic_klass_suite.addTest(basic_klass_list_subklasses("test_list_subklasses"))
basic_klass_suite.addTest(basic_klass_add_subklass("test_add_subklass"))
basic_klass_suite.addTest(basic_klass_remove_subklass("test_remove_subklass"))
basic_klass_suite.addTest(
    basic_klass_add_duplicate_subklass("test_add_duplicate_subklass"))
basic_klass_suite.addTest(basic_klass_get_subklass("test_get_subklass"))

method_klass_suite = unittest.TestSuite()
method_klass_suite.addTest(method_klass_test_case("runTest"))
method_klass_suite.addTest(method_klass_list_methods("test_list_methods"))
method_klass_suite.addTest(method_klass_add_method("test_add_method"))
method_klass_suite.addTest(
    method_klass_add_duplicate_method("test_add_duplicate_method"))
method_klass_suite.addTest(method_klass_remove_method("test_remove_method"))
method_klass_suite.addTest(method_klass_get_method("test_get_method"))

method_klass_rendrer_suite = unittest.TestSuite()
method_klass_rendrer_suite.addTest(method_klass_rendrer_render_methods(
    "test_render_methods"))
method_klass_rendrer_suite.addTest(
    method_klass_rendrer_render_methods_one_method("test_render_methods"))
method_klass_rendrer_suite.addTest(
    method_klass_rendrer_render_methods_two_methods("test_render_methods"))

property_klass_suite = unittest.TestSuite()
property_klass_suite.addTest(property_klass_test_case("runTest"))
property_klass_suite.addTest(property_klass_list_properties(
    "test_list_properties"))
property_klass_suite.addTest(property_klass_add_property("test_add_property"))
property_klass_suite.addTest(
    property_klass_add_duplicate_property("test_add_duplicate_property"))
property_klass_suite.addTest(property_klass_remove_property("test_remove_property"))
property_klass_suite.addTest(property_klass_get_property("test_get_property"))

property_klass_rendrer_suite = unittest.TestSuite()
property_klass_rendrer_suite.addTest(property_klass_rendrer_render_properties(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_one_property(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_two_properties(
    "test_render_properties"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary(
    "test_render_properties_dictionary"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary_one_property(
    "test_render_properties_dictionary"))
property_klass_rendrer_suite.addTest(
    property_klass_rendrer_render_properties_dictionary_two_properties(
    "test_render_properties_dictionary"))

klass_rendrer_suite = unittest.TestSuite()
klass_rendrer_suite.addTest(klass_rendrer_render_license("test_render_license"))
klass_rendrer_suite.addTest(klass_rendrer_render_name_and_subclasses(
    "test_render_name_and_subclasses"))
klass_rendrer_suite.addTest(klass_rendrer_render_imports("test_render_imports"))
klass_rendrer_suite.addTest(klass_rendrer_render_misc_definitions(
    "test_render_misc_definitions"))
klass_rendrer_suite.addTest(klass_rendrer_render_meta_types_and_accessor_calls(
    "test_render_meta_types_and_accessor_calls"))
klass_rendrer_suite.addTest(klass_rendrer_render_accessors(
    "test_render_accessors"))
klass_rendrer_suite.addTest(klass_rendrer_render_misc_headers(
    "test_render_misc_headers"))
klass_rendrer_suite.addTest(klass_rendrer_render_add_function(
    "test_render_add_function"))
klass_rendrer_suite.addTest(klass_rendrer_render_initialize_class(
    "test_render_initialize_class"))

klass_suite = unittest.TestSuite()
klass_suite.addTest(
    klass_add_subklass_test_duplication("test_add_subklass_duplication"))
klass_suite.addTest(klass_add_add_form("test_add_add_form"))

def test_suite():
    """Return a unittest.TestSuite instance"""
    return unittest.TestSuite((basic_klass_suite,
                               method_klass_suite,
                               method_klass_rendrer_suite,
                               property_klass_suite,
                               property_klass_rendrer_suite,
                               klass_rendrer_suite,
                               klass_suite,))

if __name__ == '__main__':
    unittest.TextTestRunner().run(test_suite())
