from OFS import SimpleItem, PropertyManager



class Sequence(SimpleItem.SimpleItem,
               PropertyManager.PropertyManager):
    """ """

    meta_type = 'Sequence'
    icon = 'misc_/ZOQLMethod/Sequence'


    _properties = ({'id': 'increment', 'type': 'int', 'mode': 'w'},
                   {'id': 'minvalue',  'type': 'int', 'mode': 'w'},
                   {'id': 'maxvalue',  'type': 'int', 'mode': 'w'},
                   {'id': 'start',     'type': 'int', 'mode': 'w'})

    manage_options = ( PropertyManager.PropertyManager.manage_options+
                       SimpleItem.Item.manage_options )
    

    def __init__(self, name, increment=1, minvalue=0,
                 maxvalue=1000000, start=0):
        ''' '''

        self.__name__ = name
        self.increment = increment
        self.minvalue = minvalue
        self.maxvalue = maxvalue
        self.start = start

        self.counter = self.start


    def reset(self):
        ''' '''
        self.counter  = self.start
        

    def last_value(self):
        ''' '''
        return self.counter
        

    def next_value(self):
        ''' '''
        if ( self.counter + self.increment < self.maxvalue and
             self.counter + self.increment < self.minvalue ):
            self.counter += self.increment
            return self.counter
        else:
            raise 'CounterOutOfBounceError', 'Counter out of bounce.'
    
