# This code is copyrighted by Stephan Richter and
# Thomas Foerster in September, 2001.
#
# written by Stephan Richter
# Last updated: October 4, 2001

#XXX clean up this module, it really looks horribly

### interpretation functions and regexen for terminals

## NOTE: kwParsing uses the deprecated regex module

from DateTime.DateTime import DateTime
from string import letters, digits
import string
import ParsedObjects
    
def DeclareComments(Grammar):
    """Declare regexen for comments"""

    # python style comments
    commentre = "#.*" 
    Grammar.comments([commentre])

    
def DeclareTerminals(Grammar):
    """ Declaration of terminal symbols """

    def Any(strlist):
        """Build more complex regexen"""
        regstr = '('+string.join(strlist, ')|(')+')'
        return regstr

    ## python terminals
    identre = "[%s_][%s%s_]*" % (letters, letters, digits)

    # literals
    sstrre = "'[^\n\\']*'"
    dstrre = '"[^\n\\"]*"'

    stringre = Any([sstrre, dstrre])
    ##XXX no long strings yet (necessary?)

    rawstringre = "r(%s)" % stringre
    zoperefre = "z(%s)" % stringre
    datetimere = "d(%s)" % stringre
    
    # number terminals
    intre = "([1-9][0-9]*)|(0)"
    ##XXX no hex and octal integers yet
    lintre = "(%s)[lL]" % (intre)

    zerore = "(%s)\." % (intre)
    fracre = "(%s)?\.[0-9]+"
    exponentre = "[eE][\+\-][0-9]*"
    pointfloatre = Any([zerore,fracre])
    expfloatre = '(' + Any([intre, pointfloatre]) +')' + exponentre

    floatre = Any([expfloatre, pointfloatre])

    ## NOTE: Ordering of the definitions is important,
    ## kwParsing seems to use first
    ## matching rule, not longest match
    
    Grammar.Addterm("datetime", datetimere, makeDateTime)
    Grammar.Addterm("zoperef", zoperefre, createReference)
    Grammar.Addterm("rawstring", rawstringre, None)
    Grammar.Addterm("string_literal", stringre, stripfn)
    Grammar.Addterm("floatnumber", floatre, evalfn)
    Grammar.Addterm("longinteger", lintre, evalfn)
    Grammar.Addterm("integer", intre, evalfn)
    Grammar.Addterm("identifier", identre, createIdentifier)
    Grammar.Addterm("plusequal", "\+\=", None)
    Grammar.Addterm("minusequal", "\-\=", None)
    Grammar.Addterm("mulequal", "\*\=", None)
    Grammar.Addterm("divequal", "\/\=", None)
    Grammar.Addterm("modequal", "\%\=", None)
    Grammar.Addterm("plus", "\+", None)
    Grammar.Addterm("minus", "\-", None)
    Grammar.Addterm("dast", "\*\*", None)
    Grammar.Addterm("ast", "\*", None)
    Grammar.Addterm("slash", "/", None)
    Grammar.Addterm("percent", "%", None)
    Grammar.Addterm("dless", "<<", None)
    Grammar.Addterm("dgreater", ">>", None)
    Grammar.Addterm("gtequal", ">=", None)
    Grammar.Addterm("ltequal", "<=", None)
    Grammar.Addterm("nequal", "<>", None)
    Grammar.Addterm("nequal", "!=", None)
    Grammar.Addterm("equal", "==", None)
    Grammar.Addterm("assign", "\=", None)
    Grammar.Addterm("less", "<", None)
    Grammar.Addterm("greater", ">", None)
    Grammar.Addterm("amper", "&", None)
    Grammar.Addterm("pipe", "|", None)
    Grammar.Addterm("circumflex", "\^", None)
    Grammar.Addterm("tilde", "~", None)


### Evaluation Functions for Terminals
def makeDateTime(str):
    return DateTime(str[2:-1])

def createReference(str):
    return ParsedObjects.Reference(str[2:-1])

def createIdentifier(str):
    return ParsedObjects.Reference(str)

def evalfn(str):
    """Evaluate String"""
    return eval(str)

def stripfn(str):
    """Strip first and last char of string"""
    return str[1:-1]
