import sys, os, string
import unittest

from Products.ZOQLMethod.Parser import ZOQLParser

### This class test whether the grammar compiles and checks for
### grammar ambiguities

class SetupTest(unittest.TestCase):

    def setUp(self):
        try: os.remove("temp.out")
        except: pass

        try: os.remove("oql.mar")
        except: pass

        
    def testGrammarBuild(self):
        """Test Compiling of Grammar"""
        orig = sys.stdout
        sys.stdout = open("temp.out", "w")
        self.parser = ZOQLParser.ZOQLParser(marshalfile="oql.mar", bind=0)
        sys.stdout.close()
        sys.stdout = orig

        output = open("temp.out", "r").read()
        
        self.assertEqual(string.find(output, "reduce/reduce conflict"), -1, "Reduce/Reduce Ambiguities found")
        self.assertEqual(string.find(output, "shift/reduce conflict"), -1, "Shift/Reduce Ambiguities found")        
