import os, sys, unittest
sys.path.append('..')

try:
    import Zope
except:
    # for correct zope import we must be in zope/lib/python
    sys.path.insert(1, os.getcwd())
    os.chdir('../../..')
    import Zope
    
from Testing import makerequest
from Products.ZOQLMethod.Parser import ZOQLExceptions

class ZOQLCreateIndexTests(unittest.TestCase):

    def setUp(self):
        
        #XXX make use of a DemoStorage and ZEO
        self.app=makerequest.makerequest(Zope.app())

        # create a product and a class to play with
        self.app.Control_Panel.Products.manage_addProduct('TestProduct', 'TestProduct product')
        self.p = self.app.Control_Panel.Products.TestProduct

        #!!! w/o CreateAFactory the meta type will not be found
        # not registered ???
        self.p.manage_addZClass('TestClass','Class for Unittesting',
                                meta_type='TestClass', CreateAFactory=1, zope_object=1)
        self.p.manage_addZClass('TestClassZ','Class for Unittesting',
                                meta_type='Zopish Test Class', CreateAFactory=1, zope_object=1)
        
        # create nested playground
        self.app.manage_addFolder('TestFolder')
        self.app.TestFolder.manage_addFolder('A')
        self.app.TestFolder.manage_addFolder('B')
        self.app.TestFolder.manage_addDTMLMethod('m')
        self.app.TestFolder.manage_addDTMLDocument('index_html')
        self.app.TestFolder.A.manage_addDTMLDocument('index_html')
        
    def tearDown(self):
        get_transaction().abort()
        self.app._p_jar.close()


    ########### Tests ##############

    def testSimpleIndex(self):
        self.app.manage_addProduct['ZOQLMethod'].manage_addZOQLMethod(
            id='createIndex', query="CREATE INDEX all ON z'DTML Document' HAVING id:text, title:text;",
            base_folder='TestFolder')

        self.app.createIndex()
        self.failUnless(hasattr(self.app.TestFolder, 'all'))
        index = self.app.TestFolder.all

        self.failUnlessEqual(index.indexes(),
                             ['id', 'path', 'title', 'meta_type'])

        self.failUnlessEqual(len(index._catalog()), 1)
        
        #XXX check index contents


    def testSimpleIndexRecursive(self):
        self.app.manage_addProduct['ZOQLMethod'].manage_addZOQLMethod(
            id='createIndex', query="CREATE INDEX all ON z'DTML Document' HAVING id:text, title:text RECURSIVE;",
            base_folder='TestFolder')

        self.app.createIndex()
        self.failUnless(hasattr(self.app.TestFolder, 'all'))
        index = self.app.TestFolder.all

        self.failUnlessEqual(index.indexes(),
                             ['id', 'path', 'title', 'meta_type'])
        self.failUnlessEqual(len(index._catalog()), 2)

        #XXX check index contents
        
                    

if __name__ == '__main__':
    unittest.main()


